<?php

$bannersObj = new banners();

class banners {

    public Iplus $mDb;
    public array $mConfig;
    public string $dateTime;
    public string $lang_code;

    public function __construct() {
        global $Config;

        $this->mDb = new Iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = defined('LANGUAGE') ? LANGUAGE : 'en'; // Default to 'en' if LANGUAGE is not defined
    }

    function getBanners($aStart, $aLimit, $sort, $type, $searchTitle, $searchAffiliator_id, $searchServiceId) {

        if ($searchServiceId) {
            $chidIds = $this->getIdsOfChidService($searchServiceId);
            if ($chidIds) {
                $searchServiceId .= ',' . $chidIds;
                // p($searchServiceId);
            }
        }



        $sql = "SELECT p.* ,pl.title , u.user_name AS 'addedBy' , u2.user_name AS 'affiliator_name' FROM banners p";
        $sql .= " LEFT JOIN `banner_langs` pl ON p.id = pl.banner_id   AND pl.lang_code ='{$this->lang_code}'  ";
        $sql .= " LEFT JOIN `users` u ON u.id = p.admin_id ";
        $sql .= " LEFT JOIN `users` u2 ON u2.id = p.affiliator_id ";
        $sql .= " LEFT JOIN `banner_services` ps ON ps.banner_id = p.id ";

        $sql .= " WHERE p.id > 0  ";

        $sql .= $searchTitle ? ' AND pl.title like "%' . $searchTitle . '%" ' : '';
        $sql .= $searchAffiliator_id ? " AND p.`affiliator_id` ='{$searchAffiliator_id}' " : " ";
        $sql .= $searchServiceId ? " AND ps.`service_id` in  ({$searchServiceId})  " : "";

        $sql .= " Group by p.id  ORDER BY p.{$sort} {$type}";

        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

        //  echo $sql; die();


        $res = $this->mDb->getAll($sql);

        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['ser_name'] = $this->getAllServicesNameOfBannerById($res[$i]['id']);
            }
        }
        return $res;
    }

    function getSearchBannersCount($sort, $type, $searchTitle, $searchAffiliator_id, $searchServiceId) {

        if ($searchServiceId) {
            $chidIds = $this->getIdsOfChidService($searchServiceId);
            if ($chidIds) {
                $searchServiceId .= ',' . $chidIds;
                // p($searchServiceId);
            }
        }

        $sql = "SELECT COUNT(DISTINCT  `p`.`id`) as 'result_count' FROM banners p";
        $sql .= " LEFT JOIN `banner_langs` pl ON p.id = pl.banner_id ";

        $sql .= " LEFT JOIN `banner_services` ps ON ps.banner_id = p.id ";

        $sql .= " WHERE p.`id` > 0";
        $sql .= $searchTitle ? ' AND pl.`title` like "%' . $searchTitle . '%"' : '';
        $sql .= $searchAffiliator_id ? " AND p.`affiliator_id` ='{$searchAffiliator_id}' " : " ";
        $sql .= $searchServiceId ? " AND ps.`service_id` in  ({$searchServiceId})  " : "";
        $sql .= " ORDER BY p.{$sort} {$type}";

        //    echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function getBannersCount() {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'count' FROM `banners`";
        return $this->mDb->getOne($sql);
    }

    function addEditBanner($temp) {
        $temp['active'] = $temp['active'] ? '1' : '0';

        if ($temp['id'] === null || $temp['id'] === '') {
            // add

            $sql = "INSERT INTO `banners` SET ";
            foreach ($this->mDb->getCols('banners', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
            // echo "$sql";die();
            $res = $this->mDb->query($sql);
            if ($res) {
                $id = $this->mDb->getLastInsertId();
                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `banner_langs` SET  lang_code = '{$v['lang_code']}'  , title = '{$v['details']['title']}' , banner_id='{$id}' ";
                    // echo "$sql";die();
                    $res2 = $this->mDb->query($sql);
                }
                $this->addBanner_services($temp['banner_services'], $id);
                # code...
            }
            return $res;
        } else {

            // edit
            if ($temp['image'] == '') { //remove image if we removed
                $image = $this->getimg($temp['id']);
                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/banners/' . $image;
                if (file_exists($old_img)) {
                    @unlink($old_img);
                }
            }
            $sql = "UPDATE `banners` SET ";
            foreach ($this->mDb->getCols('banners', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'id' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
            $res = $this->mDb->query($sql);
            if ($res) {


                $this->deleteBanner_services($temp['id']);
                $this->addBanner_services($temp['banner_services'], $temp['id']);

                //delete lang_details
                $sql = "DELETE FROM `banner_langs` ";
                $sql .= " WHERE banner_id='{$temp['id']}'  ";
                $res2 = $this->mDb->query($sql);

                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `banner_langs` SET  lang_code = '{$v['lang_code']}' , title = '{$v['details']['title']}'   ,banner_id='{$temp['id']}' ";
                    // echo "$sql";die();
                    $res2 = $this->mDb->query($sql);
                }

                # code...
            }

            return $res;
        }
    }

    public function deleteBanner_services($banner_id) {
        $sql = "DELETE From `{$this->mPrefix}banner_services`   ";
        $sql .= "where banner_id ='{$banner_id}'   ";
        $this->mDb->query($sql);
    }

    public function addBanner_services($banner_services, $banner_id) {
        if (count($banner_services) > 0) {

            foreach ($banner_services as $k => $v) {
                if ($v) {
                    $sql = "INSERT INTO `{$this->mPrefix}banner_services` SET ";
                    $sql .= " banner_id ='{$banner_id}' ,  service_id ='{$v['service_id']}'  ";
                    // echo $sql;die();
                    $res = $this->mDb->query($sql);
                }
            }
        }
    }

    function getOneBanner($id) {



        $sql = "SELECT b.* , u2.user_name AS 'affiliator_name'  FROM `banners` b";
        $sql .= " LEFT JOIN `users` u2 ON u2.id = b.affiliator_id ";

        $sql .= " WHERE b.`id` = '{$id}' ";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $sql = "SELECT lang_code ,title   FROM `banner_langs`";
            $sql .= " WHERE `banner_id` = '{$id}' ";
            $res['lang_parameter'] = $this->mDb->getAll($sql);

            $res['banner_services'] = $this->getBanner_services($id);
        }
        return $res;
    }

    public function getBanner_services($id) {
        $sql = "SELECT ps.service_id  , s.parent     FROM banner_services  ps "; //VIP
        $sql .= " LEFT JOIN `services` s ON s.id = ps.service_id  ";
        $sql .= " WHERE `banner_id` = '{$id}' order by s.service_system_commission  asc  ";
        return $this->mDb->getAll($sql);
    }

    function getimg($id) {
        $sql = "SELECT `image` FROM `banners`";
        $sql .= " WHERE `id` = '{$id}' ";
        return $this->mDb->getOne($sql);
    }

    function deleteBanner($ids) {

        $sql = "DELETE FROM `banners` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {
            $image = $this->getimg($id);
            $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/banners/' . $image;

            if (file_exists($old_img)) {
                @unlink($old_img);
            }
            $sql .= " || `id` = '{$id}' ";
        }
        // echo "$sql";die();

        return $this->mDb->query($sql);
    }

    function getIdsOfChidService($id) {
        $sql = "SELECT id FROM `services`";
        $sql .= " WHERE `parent` = '{$id}' ";
        $res = $this->mDb->getAll($sql);
        if ($res) {
            return fetchArrayValue_from_dataBase($res, 'id');
        }
    }

    public function getAllServicesNameOfBannerById($id, $limit = '') {

        $sql = "SELECT sl.ser_name FROM banner_services  ps ";
        $sql .= " LEFT JOIN `service_langs` sl ON sl.service_id = ps.service_id  AND  sl.lang_code = '{$this->lang_code}'  ";
        $sql .= " WHERE ps.`banner_id` = '{$id}'   ";
        $sql .= $limit ? " Limit  1 " : " ";

        // echo  $sql ;die();

        $res = $this->mDb->getAll($sql);
        return fetchArrayValue_from_dataBase($res, 'ser_name');
    }
}
