<?php

$trademarksObj = new Trademarks();

class Trademarks {

    private IPlus $mDb;
    private array $mConfig;
    private string $dateTime;
    public string $lang_code;

    public function __construct() {
        global $Config;
        $this->mDb = new IPlus();
        $this->mConfig = isset($Config) ? $Config : [];
        $this->dateTime = (new DateTime())->format('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE;
    }

    function getTrademarks($aStart, $aLimit, $sort, $type, $searchTitle, $active = '') {

        $sql = "SELECT t.* ,tl.title, u.user_name AS 'addedBy' FROM trademarks t";
        $sql .= " LEFT JOIN `trademark_langs` tl ON t.id = tl.trademark_id ";

        $sql .= " LEFT JOIN `users` u ON u.id = t.admin_id ";

        $sql .= " WHERE t.id > 0  AND tl.lang_code ='{$this->lang_code}'  ";

        $sql .= $searchTitle ? ' AND (tl.title like "%' . $searchTitle . '%" ||  t.code like "%' . $searchTitle . '%" ) ' : '';
        $sql .= $active ? " AND  t.active ='1' " : "";

        $sql .= $sort == 'title' ? " ORDER BY tl.{$sort} {$type} " : " ORDER BY t.{$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

//        echo $sql . "<hr>";

        return $this->mDb->getAll($sql);
    }

    function getSellers($aStart, $aLimit, $sort, $type, $searchTitle) {

        $sql = "SELECT id,name FROM sellers  ";
        $sql .= " WHERE  id > 0  AND   active ='1'  ";
        $sql .= $searchTitle ? ' AND name like "%' . $searchTitle . '%"  ' : '';
        $sql .= " ORDER BY {$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

//		   echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    function getSearchTrademarksCount($sort, $type, $searchTitle) {
        $sql = "SELECT COUNT(DISTINCT t.`id`) as 'result_count' FROM trademarks t ";
        $sql .= " LEFT JOIN `trademark_langs` tl ON t.id = tl.trademark_id ";

        $sql .= " WHERE t.`id` > 0";

        $sql .= $searchTitle ? ' AND ( tl.title like "%' . $searchTitle . '%" ||  t.code like "%' . $searchTitle . '%" ) ' : '';

        //echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function getTrademarksCount() {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'count' FROM `trademarks`";
        return $this->mDb->getOne($sql);
    }

    function addEditTrademark($temp, $mode = '') {
        $temp['active'] = $temp['active'] ? '1' : '0';
        $temp['sort'] = $temp['sort'] ? $temp['sort'] : '0';

        if (($temp['id'] === null || $temp['id'] === '') && $temp['code'] != "") {
            // add
            // code added by ahmadklsany VI*******************************
            // rename('../uploads/trademarks/thumbs/' . $temp['image'], $temp['code'] . '.jpg');
            rename('../uploads/' . DEALERUPLOAD . '/trademarks/' . $temp['image'], '../uploads/' . DEALERUPLOAD . '/trademarks/' . $temp['code'] . '.jpg');
            $temp['image'] = $temp['code'] . '.jpg';
            //VI*******************************
            if ($mode == 'excel') {
                unset($temp['date_added']);
            }

            $sql = "INSERT INTO `trademarks` SET ";
            foreach ($this->mDb->getCols('trademarks', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'lang_parameter' || $k == 'title' || $k == 'id') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
//              echo $sql."<hr>";
            $res = $this->mDb->query($sql);
            if ($res) {
                $id = $this->mDb->getLastInsertId();
                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `trademark_langs` SET  lang_code = \"{$v['lang_code']}\" , title = \"{$v['details']['title']}\" , description = \"{$v['details']['description']}\"  , trademark_id='{$id}' ";
                    // echo "$sql";die();
                    $this->mDb->query($sql);
                }


                # code...
            }
            return $res;
        } else {

            // code added by ahmadklsany VI*******************************
            // rename('../uploads/trademarks/thumbs/' . $temp['image'], $temp['code'] . '.jpg');
            rename('../uploads/' . DEALERUPLOAD . '/trademarks/' . $temp['image'], '../uploads/' . DEALERUPLOAD . '/trademarks/' . $temp['code'] . '.jpg');
            $temp['image'] = $temp['code'] . '.jpg';
            //VI*******************************

            $sql = "UPDATE `trademarks` SET ";
            foreach ($this->mDb->getCols('trademarks', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'id' || $k == 'lang_parameter' || $k == 'title') ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
            //  echo $sql."<hr>";
            // die();
            $res = $this->mDb->query($sql);

            if ($res) {

                //delete lang_details
                $sql = "DELETE FROM `trademark_langs` ";
                $sql .= " WHERE trademark_id='{$temp['id']}'  ";
                $this->mDb->query($sql);

                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `trademark_langs` SET  lang_code = \"{$v['lang_code']}\", title = \"{$v['details']['title']}\" , description = \"{$v['details']['description']}\"   ,trademark_id='{$temp['id']}' ";
                    // echo "$sql";die();
                    $this->mDb->query($sql);
                }



                # code...
            }

            return $res;
        }
    }

    function getOneTrademark($id) {
        $sql = "SELECT * FROM `trademarks`";
        $sql .= " WHERE `id` = '{$id}' ";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $sql = "SELECT lang_code ,title,description FROM `trademark_langs`";
            $sql .= " WHERE `trademark_id` = '{$id}' ";
            $res['lang_parameter'] = $this->mDb->getAll($sql);
        }
        // echo "<pre>";print_r($res);die();
        return $res;
    }

    function deleteTrademark($ids) {
        $sql = "DELETE FROM `trademarks` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {

            $sql .= " || `id` = '{$id}' ";
        }

        return $this->mDb->query($sql);
    }

    public function copyImgToServer($image_name, $path, $uploadFolder = 0, $thumbsFolder = 0) {
        //        $ext_ = pathinfo($path, PATHINFO_EXTENSION);
        //        echo $ext_."<hr>";
        //        $ext = explode("?", $ext_);
        // $newname = (substr(md5(uniqid(rand())), 0, 10)) . '.jpg';
        if ($uploadFolder) {
            copy($path, $uploadFolder . $image_name);
        }
        if ($thumbsFolder) {
            copy($path, $thumbsFolder . $image_name);
        }
        // return $newname;
    }

    //For excel sheet
    function getTrademarksExcel($trademark_id) {

        $sql = "SELECT t.* ,tl.title  FROM trademarks t";
        $sql .= " LEFT JOIN `trademark_langs` tl ON t.id = tl.trademark_id AND tl.lang_code ='{$this->lang_code}'  ";
        $sql .= " WHERE t.id > 0 ";
        $sql .= $trademark_id ? " AND t.id = '{$trademark_id}' " : " ";
        $sql .= $trademark_id ? " " : " ORDER BY tl.title ASC ";
        if ($trademark_id) {
            return $this->mDb->getRow($sql);
        } else {
            return $this->mDb->getAll($sql);
        }
    }

    //For excel sheet
    function getSellersExcel($seller_id) {

        $sql = "SELECT id,name ,active FROM sellers  ";
        $sql .= " WHERE id > 0  ";
        $sql .= $seller_id ? " AND id = '{$seller_id}' " : " ";
        $sql .= $seller_id ? " " : " ORDER BY name ASC ";
        if ($seller_id) {
            return $this->mDb->getRow($sql);
        } else {
            return $this->mDb->getAll($sql);
        }
    }

    function getIdsOfChidServiceIn($ids) {
        $sql = "SELECT id FROM `services`";
        $sql .= " WHERE `parent` in  ({$ids})   ";
//        echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);

        if ($res) {
            return fetchArrayValue_from_dataBase($res, 'id');
        }
    }

    public function getFomsShapeByService_ids($service_ids, $searchTitle = '', $aStart = '', $aLimit = '') {
        $sql = "SELECT f.id , fso.id as value ,fl.label  parent_label, fol.label  FROM `form_shapes` f  ";
        $sql .= " LEFT JOIN `form_shape_options` fso ON f.id = fso.form_shape_id    ";
        $sql .= " LEFT JOIN `form_shape_option_langs` fol ON fso.id = fol.form_shape_option_id AND fol.lang_code = '{$this->lang_code}' ";
        $sql .= " LEFT JOIN `form_shape_services` fss ON f.id = fss.form_shape_id    ";
        $sql .= " LEFT JOIN `form_shape_langs` fl ON f.id = fl.form_shape_id  AND fl.lang_code = '{$this->lang_code}' ";
        $sql .= " where (f.type='select' || f.type='m_select' ) AND fss.`service_id` in  ({$service_ids})  and f.is_deleted = '0' and f.active = '1' and   fso.is_deleted = '0'  ";
        $sql .= $searchTitle ? ' AND (fl.label like "%' . $searchTitle . '%" ||  fol.label like "%' . $searchTitle . '%" ) ' : '';
        $sql .= " Group By fso.id  ORDER BY f.sort ASC, fso.sort ASC";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//       echo $sql."<hr>";
        $form_shape = $this->mDb->getAll($sql);

//	p($sql);
//        for ($i = 0; $i < count($form_shape); $i++) {
//            $sql = "SELECT  fo.id as value , fol.label   FROM `form_shape_options` fo ";
//            $sql .= " LEFT JOIN `form_shape_option_langs` fol ON fo.id = fol.form_shape_option_id AND fol.lang_code = '{$this->lang_code}' ";
//            $sql .= " WHERE fo.form_shape_id = '{$form_shape[$i]['id']}' and fo.is_deleted = '0' ";
//            $sql .= " order by fo.sort asc ";
////          echo $sql."<hr>";
//            $form_shape[$i]['options'] = $this->mDb->getAll($sql);
//        }

        return $form_shape;
    }

    function getAllIdsWithChidServiceToAffiliator() {
        $sql = "SELECT afs.service_id FROM `affiliator_services` afs ";
        $sql .= " LEFT JOIN `services` s ON s.id = afs.service_id ";

        $sql .= " WHERE  s.active = '1' ";
// echo $sql."<hr>";

        $main = $this->mDb->getAll($sql);
        $data['main'] = fetchArrayValue_from_dataBase($main, 'service_id');

        $data['sub'] = $this->getIdsOfChidServiceIn($data['main']);
//  p( $data['sub']);
        $all_ids = '';
        if ($data['main']) {
            $all_ids .= $data['main'];
        }
        if ($data['sub']) {
            $all_ids = $all_ids ? $all_ids . "," . $data['sub'] : $data['sub'];
        }
// p($all_ids);

        return $all_ids;
    }
}
