<?php

/* * *************************************************************************
 *
 *   PROJECT: school managment system
 *   powerd by ashraf hamdy
 *   Copyright 2018 IT Plus Inc
 *   http://it-plus.co/
 *
 *
 * ************************************************************************* */

class iplus {

    public $mDbhost;
    public $mDbuser;
    public $mDbpwd;
    public $mDbname;
    public static $handel;

    function __construct(){
        global $Config;
        $this->mDbhost = $Config['dbhost'];
        $this->mDbuser = $Config['dbuser'];
        $this->mDbpwd = $Config['dbpwd'];
        $this->mDbname = $Config['dbname'];
        $this->connect();

        $this->mMailer = new Mailer();
        $this->mMailer->mConfig = $Config;
        $this->mConfig = $Config;
    }
    public function connect() {
        if (isset($this->mDb)) {
            return $this->mDb; // إرجاع كائن PDO المخزن مسبقا
        }
        $dsn = "mysql:host=$this->mDbhost;dbname=$this->mDbname;";
        $user = $this->mDbuser;
        $pass = $this->mDbpwd;
        $option = array(
            PDO::MYSQL_ATTR_INIT_COMMAND => 'SET NAMES utf8',
        );
        try {
            $this->mDb = new PDO($dsn, $user, $pass, $option);
            $this->mDb->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
            return $this->mDb; // إرجاع كائن PDO بعد الاتصال الناجح
        } catch (PDOException $e) {
            echo "Failed To Connect " . $e->getMessage();
        }
    }
    function query($aSql) {
        $query = $this->connect()->prepare($aSql);
        return $query->execute();
    }

    function queryReturnRowCount($aSql) {
        $query = $this->connect()->prepare($aSql);
        $query->execute();
        return $query->rowCount();
    }

    function queryreturnlastid($aSql) {
        $con = $this->connect();
        $query = $con->prepare($aSql);
        $query->execute();
        return $con->lastInsertId();
    }

    function getRow($aSql) {
        $query = $this->connect()->prepare($aSql);
        $query->execute();
        return $query->fetch(PDO::FETCH_ASSOC);
    }
    function getAll($aSql) {
        $query = $this->connect()->prepare($aSql);
        $query->execute();
        return $query->fetchAll(PDO::FETCH_ASSOC);
    }

    function &getAssoc($aSql) {
        $out = array();
        $res = &$this->connect()->prepare($aSql);
        $res->execute();

        while ($temp = $res->fetch(PDO::FETCH_ASSOC)) {
            $key = array_shift($temp);
            $out[$key][] = $temp;
        }
        return $out;
    }
    function getOne($aSql) {

        $query = $this->connect()->prepare($aSql);
        $query->execute();
        return $result = $query->fetchColumn(0);
    }
    function getTables() {
        $out = array();

        $sql = "SHOW TABLES FROM {$this->mDbname}";
        $res = $this->connect()->prepare($sql);
        $res->execute();
        while ($row = $res->fetch()) {
            $out[] = $row[0];
        }

        return $out;
    }
    function printError($aError) {
        echo $aError;
    }
    function getCols($tableName, $Req) {
        $aSql = "SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = N'" . $tableName . "' and TABLE_SCHEMA = '" . $this->mDbname . "' ";
        $query = $this->connect()->prepare($aSql);
        $query->execute();
        $out = array();
        while ($temp = $query->fetch(PDO::FETCH_ASSOC)) {
            if ($temp['COLUMN_NAME'] != 'id' && $temp['COLUMN_NAME'] != 'id') {
                if (isset($Req[$temp['COLUMN_NAME']])) {
                    $return[$temp['COLUMN_NAME']] = $Req[$temp['COLUMN_NAME']];
                }
            }
        }

        return $return;
    }

    function getColumnName($tableName) {
        $aSql = "SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = N'" . $tableName . "' and TABLE_SCHEMA = '" . $this->mDbname . "' ";
        $aSql.="  ORDER BY `ORDINAL_POSITION` ASC ";
        $query = $this->connect()->prepare($aSql);
        $query->execute();
        $return = array();

        while ($temp = $query->fetch(PDO::FETCH_ASSOC)) {
            if ($temp['COLUMN_NAME'] != 'id' && $temp['COLUMN_NAME'] != 'admin_id' && $temp['COLUMN_NAME'] != 'date_added') {

                $arr = explode("_", $temp['COLUMN_NAME']);
                $arrpop = $arr;
                array_pop($arrpop);
                $arrpop = implode("_", $arrpop);
                $i = array_search(reset($arr), array_column($return, 'mode'));

                if ($i > -1 && end($arr) !== 'show') {

                    $i3 = array_search($arrpop, array_column($return[$i]['options'], 'mode'));
                    if ($i3 > -1) {
                        $return[$i]['options'][$i3][$temp['COLUMN_NAME']] = $temp['COLUMN_DEFAULT'];
                    } else {
                        $options = array();
                        $options['mode'] = $arrpop;
                        $options[$temp['COLUMN_NAME']] = $temp['COLUMN_DEFAULT'];
                        array_push($return[$i]['options'], $options);
                    }
                } else {
                    if (end($arr) == 'show') {
                        $i2 = array_search(reset($arr), array_column($return, 'mode'));
                        if ($i2 > -1) {
                            $return[$i2][$temp['COLUMN_NAME']] = $temp['COLUMN_DEFAULT'];
                        } else {
                            array_push($return, ["mode" => reset($arr), $temp['COLUMN_NAME'] => $temp['COLUMN_DEFAULT'], "options" => array()]);
                        }
                    } else {
                        array_push($return, ["mode" => reset($arr), $temp['COLUMN_NAME'] => $temp['COLUMN_DEFAULT'], "options" => array()]);
                    }
                }
            }
        }

        return $return;
    }

    function getKeyValue($aSql) {
        $out = array();
        $res = $this->connect()->prepare($aSql);
        $res->execute();
        while ($temp = $res->fetch()) {
            $out[$temp[0]] = $temp[1];
        }
        return $out;
    }

    public function getLastInsertId() {
        return $this->connect()->lastInsertId();
    }
    public function getlastIdFromTable($table) {
        $sql = " SELECT `AUTO_INCREMENT` FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_NAME = '{$table}' ";
        $res = $this->getOne($sql);

        if ($res) {
            return $res;
        } else {
            return 0;
        }
    }

    public function autoIncrementTableName($tableName) {
        $sql = " SELECT MAX(`id`) + 1 as count FROM `{$tableName}` ";
        $count = $this->getOne($sql);
        $sql = " ALTER TABLE `{$tableName}` AUTO_INCREMENT ={$count} ";
        return $this->query($sql);
    }

}