<?php

/* * *************************************************************************
 *
 *   PROJECT:  Aramedical system
 *   powerd by  IT PLUS
 *   Copyright 2013 IT Plus Inc
 *   http://it-plus.co/
 *
 * ************************************************************************* */
$settings = new Configuration();

class Configuration {

    private $mDb;
    private $masterDb;
    private $mMailer;
    private $prefix;
    private $mConfig;
    private $lang_code;

    public function __construct() {
        global $Config;

        // Initialize necessary objects
        $this->mDb = new iplus();
        $this->masterDb = new iplusMaster();
        $this->mMailer = new Mailer();

        // Apply $Config settings and set defaults
        $this->mConfig = $Config ?? [];
        $this->mMailer->mConfig = $this->mConfig;

        $this->prefix = $this->mConfig['prefix'] ?? '';
        $this->lang_code = LANGUAGE;
    }

    public function getAllContanctInfo() {
        $res = array();
        $sql = " SELECT  mobile, email , user_name ,avatar ,brief,country_id from users ";
        $sql .= " WHERE   id = " . AFFILIATOR['id'] . " ";
        // echo $sql ;die();
        $res = $this->mDb->getRow($sql);
        $options = $this->getAffiliator_options(AFFILIATOR['id']);
        $paymentGateway = $this->getAffiliator_paymentGateway(AFFILIATOR['id']);

        $generalSettings = $this->getGeneralSettings();
        $currency = $this->getCurrencyDefault($res['country_id']);

        $res['country_info'] = $this->getCountryById($res['country_id']);

        $res['customer_service']['product_page'] = $this->getAffiliatorCustomerServiceByMode(AFFILIATOR['id'], 'product_page');
        $res['customer_service']['home_page'] = $this->getAffiliatorCustomerServiceByMode(AFFILIATOR['id'], 'home_page');
        $res['customer_service']['policy_page'] = $this->getAffiliatorCustomerServiceByMode(AFFILIATOR['id'], 'policy_page');

        $common_famous = $this->getAffiliator_common_famous(AFFILIATOR['id']);

        $res['all_common_search_words'] = $this->setKeyToArray(explode(",", $common_famous['common_search_words']));

        $res['all_common_trademarks'] = $common_famous['all_common_trademarks'];

        $res['currency'] = $currency;
        $res['front_color'] = $options['front_color'];
        $res['front_color_2'] = $options['front_color_2'];
        $res['front_logo'] = $options['front_logo'];
        $res['front_fav_icon'] = $options['front_fav_icon'];
        $res['front_name'] = $options['front_name'];
        $res['instagram'] = $options['instagram'];
        $res['facebook'] = $options['facebook'];
        $res['twitter'] = $options['twitter'];
        $res['tiktok'] = $options['tiktok'];
        $res['snapchat'] = $options['snapchat'];
        $res['youtube'] = $options['youtube'];
        $res['tab_new_img'] = $options['tab_new_img'];
        $res['tab_new_name_ar'] = $options['tab_new_name_ar'];
        $res['tab_new_name_en'] = $options['tab_new_name_en'];
        $res['front_currency'] = $options['front_currency'];
        $res['show_price'] = $options['show_price'];
        $res['share_description'] = $options['share_description'];
        $res['reservation_of_products_in_app'] = $options['reservation_of_products_in_app'];
        $res['promotional_description_share'] = $options['promotional_description_share'];
        $res['full_description_share'] = $options['full_description_share'];
        $res['promotional_description_web'] = $options['promotional_description_web'];
        $res['promotional_description_app'] = $options['promotional_description_app'];
        $res['full_description_web'] = $options['full_description_web'];
        $res['full_description_app'] = $options['full_description_app'];
        $res['app_url_ios'] = $options['app_url_ios'];
        $res['app_url_android'] = $options['app_url_android'];
        $res['contact_us_via_mobile'] = $options['contact_us_via_mobile'];
        $res['contact_us_via_email'] = $options['contact_us_via_email'];

        $res['opening_screen'] = $options['opening_screen'];
        $res['slider_1'] = $options['slider_1'];
        $res['slider_2'] = $options['slider_2'];
        $res['slider_3'] = $options['slider_3'];
        $res['slider_4'] = $options['slider_4'];
        $res['title_page_welcome_1'] = $options['title_page_welcome_1'];
        $res['title_page_welcome_2'] = $options['title_page_welcome_2'];
        $res['title_page_login_1'] = $options['title_page_login_1'];
        $res['title_page_login_2'] = $options['title_page_login_2'];
        $res['title_page_header_1'] = $options['title_page_header_1'];
        $res['title_page_header_2'] = $options['title_page_header_2'];
        $res['text_page_profile_footer_1'] = $options['text_page_profile_footer_1'];
        $res['text_page_profile_footer_2'] = $options['text_page_profile_footer_2'];
        $res['google_analytics_id'] = $options['google_analytics_id'];
        $res['facebook_pixel_id'] = $options['facebook_pixel_id'];

        $res['shipping_method_home_name'] = $options['shipping_method_home_name'];
        $res['shipping_method_home_value'] = $options['shipping_method_home_value'];
        $res['shipping_method_from_store_name'] = $options['shipping_method_from_store_name'];
        $res['shipping_method_from_store_value'] = $options['shipping_method_from_store_value'];

        $res['delivery_times_in_store'] = $options['delivery_times_in_store'];

        $res['code_head'] = $options['code_head'];
        $res['code_body'] = $options['code_body'];
        $res['tag_title'] = $options['tag_title'];
        $res['meta_description'] = $options['meta_description'];
        $res['meta_keywords'] = $options['meta_keywords'];

        $res['register_client_on_mobile'] = $options['register_client_on_mobile'];
        $res['register_client_on_mobile_verification'] = $options['register_client_on_mobile_verification'];
        $res['register_client_on_email'] = $options['register_client_on_email'];
        $res['register_client_on_email_verification'] = $options['register_client_on_email_verification'];

        $res['payment_method_home'] = $options['payment_method_home'];
        $res['payment_method_home_price'] = $options['payment_method_home_price'];
        $res['payment_method_home_name'] = $options['payment_method_home_name'];
        $res['payment_method_home_text'] = $options['payment_method_home_text'];

        $res['payment_method_bank'] = $options['payment_method_bank'];
        $res['payment_method_bank_price'] = $options['payment_method_bank_price'];
        $res['payment_method_bank_name'] = $options['payment_method_bank_name'];
        $res['payment_method_bank_text'] = $options['payment_method_bank_text'];

        $res['payment_method_card'] = $options['payment_method_card'];
        $res['payment_method_card_price'] = $options['payment_method_card_price'];
        $res['payment_method_card_name'] = $options['payment_method_card_name'];
        $res['payment_method_card_text'] = $options['payment_method_card_text'];

        $res['payment_gateway_id'] = $options['payment_gateway_id'];
        $res['payment_gateway_currency_iso'] = $paymentGateway['currency_iso'];
        $res['payment_gateway_api_key'] = $paymentGateway['api_key'];

        $res['including_value_added_tax'] = $options['including_value_added_tax'];

        if ($generalSettings['maintenance_mode_for_all_affiliatores'] == '1') {
            $res['maintenance_mode'] = true;
            $res['maintenance_mode_message'] = $generalSettings['maintenance_mode_message_for_all_affiliatores'];
        } else {
            $res['maintenance_mode'] = $options['maintenance_mode'] == '1' ? true : false;
            $res['maintenance_mode_message'] = $options['maintenance_mode_message'];
        }


        return $res;
    }

    public function getAllContanctInfoServer() {
        $res = array();

        $options = $this->getAffiliator_optionsServer(AFFILIATOR['id']);

        $generalSettings = $this->getGeneralSettingsServer();

        $res['front_name'] = $options['front_name'];

        $res['google_analytics_id'] = $options['google_analytics_id'];
        $res['facebook_pixel_id'] = $options['facebook_pixel_id'];

        $res['code_head'] = $options['code_head'];
        $res['code_body'] = $options['code_body'];
        $res['tag_title'] = $options['tag_title'];
        $res['meta_description'] = $options['meta_description'];
        $res['meta_keywords'] = $options['meta_keywords'];

        if ($generalSettings['maintenance_mode_for_all_affiliatores'] == '1') {
            $res['maintenance_mode'] = true;
            $res['maintenance_mode_message'] = $generalSettings['maintenance_mode_message_for_all_affiliatores'];
        } else {
            $res['maintenance_mode'] = $options['maintenance_mode'] == '1' ? true : false;
            $res['maintenance_mode_message'] = $options['maintenance_mode_message'];
        }


        return $res;
    }

    public function getAffiliator_optionsServer($user_id) {

        $sql = "SELECT ao.front_name,ao.google_analytics_id,ao.facebook_pixel_id,ao.maintenance_mode,ao.maintenance_mode_message,ao.code_head,ao.code_body,aol.tag_title,aol.meta_description,aol.meta_keywords";
        $sql .= " FROM `affiliator_options` ao ";
        $sql .= " LEFT JOIN `affiliator_options_langs` aol ON ao.id = aol.o_id and aol.lang_code='" . LANGUAGE . "'  ";
        $sql .= " WHERE   ao.user_id  ='{$user_id}'     ";
//        echo $sql."<hr>";
        $res = $this->mDb->getRow($sql);

        //  echo $sql;
        //   die();
        return $res ? $res : array();
    }

    public function setKeyToArray($common_search_words) {
        $associative_array_common_search_words = array();
        for ($i = 0; $i < count($common_search_words); $i++) {
            $associative_array_common_search_words[$i]['name'] = $common_search_words[$i];
        }
        return $associative_array_common_search_words;
    }

    public function getAffiliator_options($user_id) {

        $sql = "SELECT ao.*,aol.tag_title,aol.meta_description,aol.meta_keywords,aol.shipping_method_home_name,aol.shipping_method_from_store_name";
        $sql .= " ,aol.delivery_times_in_store,aol.payment_method_home_name,aol.payment_method_home_text ,aol.payment_method_bank_name,aol.payment_method_bank_text";
        $sql .= " ,aol.payment_method_card_name,aol.payment_method_card_text ";
        $sql .= " FROM `affiliator_options` ao ";
        $sql .= " LEFT JOIN `affiliator_options_langs` aol ON ao.id = aol.o_id and aol.lang_code='" . LANGUAGE . "'  ";
        $sql .= " WHERE   ao.user_id  ='{$user_id}'     ";
//        echo $sql."<hr>";
        $res = $this->mDb->getRow($sql);

        //  echo $sql;
        //   die();
        return $res ? $res : array();
    }

    public function getAffiliatorCustomerServiceByMode($user_id, $mode = '') {

        $sql = "SELECT cs.*,csl.label ";
        $sql .= " FROM `customer_service` cs ";
        $sql .= " LEFT JOIN `customer_service_langs` csl ON cs.id = csl.s_id and csl.lang_code='" . LANGUAGE . "'  ";
        $sql .= " WHERE cs.active='1' and  cs.affiliator_id  ='{$user_id}' ";
        $sql .= $mode ? " and  cs.mode  ='{$mode}'  " : "";
//         echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);
        //  echo $sql;
        //   die();
        return $res ? $res : array();
    }

    public function getAffiliator_paymentGateway($user_id) {

        $sql = "SELECT currency_iso,api_key";
        $sql .= " FROM `payment_gateways_affiliators`  ";
        $sql .= " WHERE   affiliator_id  ='{$user_id}'     ";
//        echo $sql."<hr>";
        $res = $this->mDb->getRow($sql);

        //  echo $sql;
        //   die();
        return $res ? $res : '';
    }

    public function getGeneralSettings() {

        $sql = "SELECT * FROM `settings` ";
        $res = $this->mDb->getAll($sql);
        $ret = array();
        for ($i = 0; $i < count($res); $i++) {
            $ret[$res[$i]['name']] = $res[$i]['value'];
        }
        return $ret;
        //  echo $sql;
        //   die();
    }

    public function getGeneralSettingsServer() {

        $sql = "SELECT maintenance_mode_for_all_affiliatores,maintenance_mode_message_for_all_affiliatores FROM `settings` ";
        $res = $this->mDb->getAll($sql);
        $ret = array();
        for ($i = 0; $i < count($res); $i++) {
            $ret[$res[$i]['name']] = $res[$i]['value'];
        }
        return $ret;
        //  echo $sql;
        //   die();
    }

    public function getCurrencyDefault($country_id) {

//        $sql = "SELECT `name_ar`,`name_en` FROM `currencies` ";
//        $sql .= " WHERE `default` ='1' ";
////        echo $sql."<hr>";
//        $res = $this->mDb->getRow($sql);
//        $ret = array();
//
//        $ret['ar'] = $res['name_ar'] ? $res['name_ar'] : "";
//        $ret['en'] = $res['name_en'] ? $res['name_en'] : "";


        $sql = "SELECT pl.`lang_code`,pl.`currency` FROM `place_langs` pl ";
        $sql .= " LEFT JOIN `places` p ON pl.place_id = p.id  ";
        $sql .= " WHERE p.`id` ='{$country_id}' ";
//     echo $sql."<hr>";
        $res = $this->masterDb->getAll($sql);
        $ret = array();
        for ($i = 0; $i < count($res); $i++) {
            $ret[$res[$i]['lang_code']] = $res[$i]['currency'];
        }
        return $ret;
        //  echo $sql;
        //   die();
    }

    public function getCountryById($id) {

        $sql = "SELECT p.id ,p.country_code ,p.image ,pl.pla_name as name,p.mobile_length,p.mobile_keys  FROM places p ";
        $sql .= " LEFT JOIN `place_langs` pl ON p.id = pl.place_id  AND pl.lang_code = '{$this->lang_code}' ";
        $sql .= " WHERE p.id ='{$id}' AND p.active = '1'  ";
        $res = $this->masterDb->getRow($sql);

        return $res ? $res : '';
        //  echo $sql;
        //   die();
    }

    public function getAffiliator_common_famous($user_id) {
        $sql = "SELECT *  FROM `affiliator_famous` ";
        $sql .= " WHERE   user_id  ='{$user_id}'     ";
        $res = $this->mDb->getRow($sql);

        if ($res['common_trademarks']) {
            $res['all_common_trademarks'] = $this->getTradeMrketByIds($res['common_trademarks']);
        }
        //  echo $sql;
        //   die();
        return $res;
    }

    public function getlastTypeIdFromByTableName($Req) {

        $sql = " SELECT  `{$Req['column_name']}` as last_item  ";
        $sql .= " FROM `{$this->mPrefix}{$Req['table_name']}` ";
        $sql .= " WHERE `{$Req['column_type']}`='{$Req['type_value']}' order by " . $Req['column_name'] . " DESC  Limit  1  ";
        // echo "<pre> ";
        // print_r($res);
        // die();
        $res = $this->mDb->getAll($sql);

        if ($res) {
            return $res[0]['last_item'];
        } else {
            return 0;
        }
    }

    public function getlastCartGroupId() {

        $sql = " SELECT  `cart_group_id` as last_item  ";
        $sql .= " FROM `{$this->mPrefix}carts` ";
        $sql .= "  order by cart_group_id DESC  Limit  1  ";
        // echo "<pre> ";
        // print_r($res);
        // die();
        $res = $this->mDb->getAll($sql);

        if ($res) {
            return $res[0]['last_item'];
        } else {
            return 0;
        }
    }

    function getTradeMrketByIds($common_trademarks) {
        $sql = "SELECT  t.image ,tl.title  , tl.trademark_id  FROM trademarks t";
        $sql .= " LEFT JOIN `trademark_langs` tl ON t.id = tl.trademark_id  AND  tl.lang_code = 'ar'  ";
        $sql .= "  where t.id in (" . $common_trademarks . ")   ";
        //  echo $sql; die();
        return $this->mDb->getAll($sql);
    }

    function checkSecritKeyIsExist($key) {
        $sql = "SELECT secrit_key FROM api_secrit_keys where secrit_key ='{$key}'  ";
        // echo $sql; die();
        return $this->mDb->getOne($sql);
    }

    function insertSecritKey($key) {
        $sql = "INSERT INTO api_secrit_keys   SET secrit_key ='{$key}'   ";
        // echo $sql; die();
        return $this->mDb->query($sql);
    }

    function getSupportAndBlogCategoryById($id = '0') {
        $sql = "SELECT   c.* ,cl.name,cl.ser_description FROM support_and_blog_category  c ";
        $sql .= " LEFT JOIN `support_and_blog_category_langs`  cl ON c.id = cl.cat_id  AND  cl.lang_code = '{$this->lang_code}'";
        $sql .= "  where c.id ='{$id}'  and c.active='1'  ";
        $sql .= " and   c.affiliators_ids like '%," . AFFILIATOR['id'] . ",%' ";
//   echo $sql."<hr>";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $res['sub'] = $this->getAllSupportAndBlogCategory($res['id'], 0, 0, 'sort', 'ASC', true);
        }
        return $res;
    }

    function getAllSupportAndBlogCategory($parent, $aStart, $aLimit, $sort, $type = '', $mode_sub = '', $mode_page = '') {
        $sql = "SELECT   c.id,c.parent,c.img,c.img_banner ,cl.name,cl.ser_description,c.show_in_header,c.show_in_footer,c.date_added FROM support_and_blog_category  c ";
        $sql .= " LEFT JOIN `support_and_blog_category_langs`  cl ON c.id = cl.cat_id  AND  cl.lang_code = '{$this->lang_code}'";
        $sql .= "  where c.parent ='{$parent}'  and c.active='1'  ";
        $sql .= " and   c.affiliators_ids like '%," . AFFILIATOR['id'] . ",%' ";
        $sql .= " ORDER BY c.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT  {$aStart}, {$aLimit} " : '';
//   echo $sql; die();
        $res = $this->mDb->getAll($sql);
        if ($res) {
            if ($mode_sub) {
                $limit = $mode_page ? 0 : 5;
                for ($i = 0; $i < count($res); $i++) {
                    $res[$i]['sub'] = $this->getAllSupportAndBlogCategory($res[$i]['id'], 0, $limit, 'sort', 'ASC', false);
                    $res[$i]['sub_count'] = count($res[$i]['sub']);
                    if ($mode_page) {
                        if( $res[$i]['sub_count'] > 0){
                            for ($p = 0; $p < count($res[$i]['sub']); $p++) {
                                $res[$i]['sub'][$p]['article'] = $this->getAllSupportAndBlogPages($res[$i]['sub'][$p]['id'], 0, 0, 'id', 'ASC',$res[$i]['sub'][$p]['sub_count']);
                            }
                        }else{
                            
                                $res[$i]['article'] = $this->getAllSupportAndBlogPages($res[$i]['id'], 0, 0, 'id', 'ASC',$res[$i]['sub_count']);
                           
                        }
                      
                    } else {
                        $res[$i]['sub_count'] = $this->getAllSupportAndBlogCategoryCount($res[$i]['id']);
                    }
                }
            } else {
                for ($i = 0; $i < count($res); $i++) {
                    $res[$i]['sub_count'] = $this->getAllSupportAndBlogCategoryCount($res[$i]['id']);
                }
            }
        }
        return $res;
    }

    function getAllSupportAndBlogCategoryCount($parent = '0') {
        $sql = "SELECT count(c.id)  FROM support_and_blog_category  c ";
        $sql .= "  where c.parent ='{$parent}'  and c.active='1'  ";
        $sql .= " and   c.affiliators_ids like '%," . AFFILIATOR['id'] . ",%' ";

//   echo $sql; die();
        $res = $this->mDb->getOne($sql);

        return $res ? $res : "0";
    }

    function getParentCategoryById($id = '0') {
        $sql = "SELECT parent FROM support_and_blog_category    ";
        $sql .= "  where id ='{$id}'    ";
        $sql .= " and    affiliators_ids like '%," . AFFILIATOR['id'] . ",%' ";
//   echo $sql; die();
        $res = $this->mDb->getOne($sql);
        return $res ? $res : "0";
    }

    function getParentPageById($id = '0') {
        $sql = "SELECT parent FROM support_and_blog_pages    ";
        $sql .= "  where id ='{$id}'    ";
        $sql .= " and  affiliator_id = " . AFFILIATOR['id'] . " ";
//   echo $sql; die();
        $res = $this->mDb->getOne($sql);
        return $res ? $res : "0";
    }

    function getSupportCategoryAndPageById($id, $mode = '') {
        if ($mode == 'article') {
            $parentId = $this->getParentPageById($id);
        } elseif ($mode == 'category') {
//            $parentId = $this->getParentCategoryById($id);
            $res_ = array_reverse($this->getBreadcrumbSupportPage($id));
            $parentId = $res_[0]['id'];
        }
        if ($parentId) {
            $res = $this->getAllSupportAndBlogCategory($parentId, 0, 0, 'sort', 'ASC', true, true);
        }
        return $res ? $res : "";
    }

    function getAllSupportAndBlogPages($sub_id, $aStart, $aLimit, $sort, $type = '', $sub_count = 0) {
        try {
            // التحقق من صحة المدخلات
            $params = [];
            $sub_id = filter_var($sub_id, FILTER_SANITIZE_NUMBER_INT);
            $aStart = filter_var($aStart, FILTER_SANITIZE_NUMBER_INT);
            $aLimit = filter_var($aLimit, FILTER_SANITIZE_NUMBER_INT);
            
            // التحقق من حقل الترتيب
            $allowed_sorts = ['id', 'date_added', 'show_in_header', 'show_in_footer'];
            $sort = in_array($sort, $allowed_sorts) ? $sort : 'id';
            
            // التحقق من نوع الترتيب
            $type = strtoupper($type);
            $type = in_array($type, ['ASC', 'DESC']) ? $type : 'ASC';

            // بناء الاستعلام الأساسي
            $sql = "SELECT p.id, p.cat_id, p.sub_id, p.mode, 
                           pl.title, pl.description,
                           p.show_in_header, p.show_in_footer, p.date_added 
                    FROM support_and_blog_pages p 
                    LEFT JOIN support_and_blog_pages_langs pl 
                        ON p.id = pl.page_id AND pl.lang_code = :lang_code
                    WHERE p.active = 1 
                    AND p.affiliator_id = :affiliator_id";
            
            $params[':lang_code'] = $this->lang_code;
            $params[':affiliator_id'] = AFFILIATOR['id'];

            // إضافة شرط التصفية
            if ($sub_count == 0) {
                $sql .= " AND p.cat_id = :sub_id";
            } else {
                $sql .= " AND p.sub_id = :sub_id";
            }
            $params[':sub_id'] = $sub_id;

            // إضافة الترتيب
            $sql .= " ORDER BY p.{$sort} {$type}";

            // إضافة حد النتائج
            if ($aLimit) {
                $sql .= " LIMIT :start, :limit";
                $params[':start'] = (int)$aStart;
                $params[':limit'] = (int)$aLimit;
            }

            // تنفيذ الاستعلام باستخدام PDO
            $stmt = $this->mDb->connect()->prepare($sql);
            foreach ($params as $key => &$val) {
                $stmt->bindParam($key, $val);
            }
       
            $stmt->execute();
//             echoSql($stmt);
            return $stmt->fetchAll(PDO::FETCH_ASSOC);

        } catch (Exception $e) {
            error_log("خطأ في getAllSupportAndBlogPages: " . $e->getMessage());
            return [];
        }
    }

    function getSearchSupportPage($aStart, $aLimit, $sort, $type, $searchName, $parent_id) {
        $sql = "SELECT   p.id ,pl.title,pl.description FROM support_and_blog_pages  p ";
        $sql .= " LEFT JOIN `support_and_blog_pages_langs`  pl ON p.id = pl.page_id  AND  pl.lang_code = '{$this->lang_code}'";
        $sql .= "  where p.parent ='{$parent_id}'  and p.active='1'  ";
        $sql .= $searchName ? ' AND pl.title like "%' . $searchName . '%"' : '';
        $sql .= " and   p.affiliator_id = " . AFFILIATOR['id'] . " ";
        $sql .= " ORDER BY p.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT  {$aStart}, {$aLimit} " : '';
        //  echo $sql; die();
        return $this->mDb->getAll($sql);
    }

       public function getSupportAndBlogPagesOne($id) {
        $sql = "SELECT   
                    p.id,
                    p.cat_id,
                    p.sub_id,
                    p.mode ,
                    pl.title,
                    pl.description,
                    p.show_in_header,
                    p.show_in_footer,
                    p.date_added 
                FROM support_and_blog_pages p
                LEFT JOIN support_and_blog_pages_langs pl 
                    ON p.id = pl.page_id  
                    AND pl.lang_code = :lang_code 
                WHERE p.id = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindValue(':lang_code', $this->lang_code);
        $stmt->bindValue(':id', $id);
        $stmt->execute();
        return $stmt->fetch(PDO::FETCH_ASSOC);
    }

    function getAllLang() {
        $sql = "SELECT CAST(`id` AS CHAR) AS id, `name`, `code`, `lang_image` FROM `languages` ";
        $sql .= " ORDER BY id ASC";
        $res = $this->mDb->getAll($sql);
        return $res;
    }

    function getSubIdPageById($id = '0') {
        $sql = "SELECT sub_id FROM support_and_blog_pages    ";
        $sql .= "  where id ='{$id}'    ";
        $sql .= " and  affiliator_id = " . AFFILIATOR['id'] . " ";
//   echo $sql; die();
        $res = $this->mDb->getOne($sql);
        return $res ? $res : "0";
    }

    function getBreadcrumbSupportCategoryAndPageById($id, $mode = '') {
        if ($mode == 'article') {
            $subId = $this->getSubIdPageById($id);
        } elseif ($mode == 'category') {
            $subId = $id;
        }
        if ($subId) {
            $res = $this->getBreadcrumbSupportPage($subId);
        }
        return $res ? $res : "";
    }

    function getBreadcrumbSupportPage($aId) {

        $sql = "SELECT s.id, sl.name,s.`parent` FROM `support_and_blog_category` s ";
        $sql .= " LEFT JOIN `support_and_blog_category_langs` sl ON s.id = sl.cat_id  AND  sl.lang_code = '{$this->lang_code}' ";
        $sql .= "WHERE s.`id`='{$aId}'";
//        echo $sql."<hr>";
        $tier = $this->mDb->getRow($sql);

        if ($tier['id']) {

            $tree[] = $tier;
            $tier_arr = $this->getBreadcrumbSupportPage($tier['parent']);
            if (is_array($tier_arr)) {
                $tree = array_merge($tree, $tier_arr);
            }
        }

        return $tree;
    }

    public function getlastIdFromByTableName($Req) {

        $sql = " SELECT  `{$Req['column_name']}` ";
        $sql .= " FROM `{$this->mPrefix}{$Req['table_name']}` ";
        $sql .= "  order by " . $Req['column_name'] . " DESC  Limit  1  ";
        $res = $this->mDb->getOne($sql);

        if ($res) {
            return $res;
        } else {
            return 1000;
        }
    }

    public function getCommitmentsAndPoliciesByMode($mode = '') {
        $sql = "SELECT  cap.id,cap.color_1,cap.color_2,cap.color_deg ,capl.name  FROM commitments_and_policies  cap ";
        $sql .= " LEFT JOIN `commitments_and_policies_langs`  capl ON cap.id = capl.p_id  AND  capl.lang_code = '{$this->lang_code}'";
        $sql .= "  where cap.id >0  ";
        $sql .= " and   cap.affiliator_id = " . AFFILIATOR['id'] . " ";
//   echo $sql."<hr>";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $res['pages'] = $this->getAllCommitmentsAndPoliciesPagesByMode($res['id'], $mode);
        }
        return $res;
    }

    public function getAllCommitmentsAndPoliciesPagesByMode($c_id, $mode = '') {
        $sql = "SELECT  capp.id,capp.page_id,capp.img ,cappl.name,cappl.description  FROM commitments_and_policies_pages  capp ";
        $sql .= " LEFT JOIN `commitments_and_policies_pages_langs`  cappl ON capp.id = cappl.p_id  AND  cappl.lang_code = '{$this->lang_code}'";
        $sql .= "  where capp.c_id='{$c_id}'  ";
        $sql .= $mode == 'show_in_product_page' ? " and  capp.show_in_product_page = '1' " : "";
        $sql .= $mode == 'show_in_order_confirmation_page' ? " and  capp.show_in_order_confirmation_page = '1' " : "";
//   echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);
        return $res;
    }

    public function GetDirectRequest() {
        $sql = "SELECT direct_request_active FROM `affiliator_options` WHERE `user_id` = :user_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->execute(['user_id' => AFFILIATOR['id']]);
        $res = $stmt->fetchColumn();
        if ($res == 1) {
            $sql = "SELECT dr.type,drl.label FROM `direct_request` dr
                    LEFT JOIN `direct_request_langs` drl ON dr.id = drl.p_id AND drl.lang_code='" . LANGUAGE . "'
                    WHERE dr.affiliator_id = :user_id AND dr.active = '1'";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->execute(['user_id' => AFFILIATOR['id']]);
            $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
            return $res;
        } else {
            return [];
        }
    }

    public function getAllSellers($temp) {
        $sql = "SELECT id,name ";
        $sql .= " FROM `sellers` ";
        $sql .= " WHERE id > 0 and active='1'";
        $sql .= $temp['SearchName'] ? ' AND name like "%' . $temp['SearchName'] . '%"' : '';
        $sql .= " ORDER BY {$temp['sort']} {$temp['type']}";
        $sql .= $temp['aLimit'] ? " LIMIT {$temp['start']}, {$temp['aLimit']}" : '';
        $res = $this->mDb->getAll($sql);
        return $res;
    }

    public function getStores($temp) {
        $sql = "SELECT 
                    t.* ,
                    tl.title,
                    tl.title_share, 
                    u.user_name AS 'addedBy' 
                FROM stores t";
        $sql .= " LEFT JOIN `store_langs` tl ON t.id = tl.store_id AND tl.lang_code ='ar' ";
        $sql .= " LEFT JOIN `users` u ON u.id = t.admin_id ";
        // $sql .= " LEFT JOIN `affiliator_stores` ast ON t.id = ast.store_id ";
        $sql .= " WHERE t.id > 0 AND t.active = '1' ";
        $sql .= $temp['searchTitle'] ? ' AND (tl.title like "%' . $temp['searchTitle'] . '%" ||  t.code like "%' . $temp['searchTitle'] . '%" ) ' : '';
        $sql .= $temp['seller_id'] ? " AND  t.seller_id = '{$temp['seller_id']}' " : '';
        // $sql .= " AND  ast.user_id = '".AFFILIATOR['id']."' ";
        $sql .= " ORDER BY t.{$temp['sort']} {$temp['type']}";
        $sql .= $temp['aItemsPerPage'] ? " LIMIT {$temp['start']}, {$temp['aItemsPerPage']}" : '';
        return $this->mDb->getAll($sql);
    }
}
